@echo off

REM
REM :: Check the health of all downloaded files in MD5.txt
REM

setlocal ENABLEDELAYEDEXPANSION ENABLEEXTENSIONS
set exitCode=0

if exist MD5.txt (
    for /F "tokens=1,2 delims==" %%I in (MD5.txt) do (
        if NOT "%%I" == ".\MD5.txt" (
            if NOT "%%~nxI" == "DONTINDX.MSA" (
                @REM the next line prints the text without newline
                echo | set /p dummyName=Checking file: %%I
                call :GetValue %%I
                set /P value=<hash.txt          
                if NOT "!value!" == "%%J" (
                    @REM the corresponding newline from above is printed here
                    echo.
                    echo **** ERROR: The following file is corrupt: %%I ****
                    set exitCode=1
                ) else (
                    echo  is OK
                )
            )
        )
    )   
    del hash.txt
) else (
    echo The file containing the MD5s of the packages is not present: MD5.txt
    pause
    exit 1
)

for /R . %%I in (join.cmd) do ( 
    if exist %%I (
        pushd %%~pI
        cmd /C join.cmd
        move *.gz "%%~pI\.."
        popd
        RD /S /Q "%%~dpI"
    )
)

if %exitCode%==1 echo The installer is not healthy. Please see above errors.
if not %exitCode%==1 echo The installer is healthy.
pause
exit %exitCode%
goto :EOF
:GetValue
@echo off
call certutil -hashfile %1 MD5>hash.txt
for /f "delims=: skip=1" %%G in (hash.txt) do if not defined line set "line=%%G"
SET char=%line:~2,1%
if not "%char%"==" " (
    call :SplitLine
)
echo %line%>hash.txt
set line=
goto :EOF

:SplitLine
set space=^ 
set newline=
set count=0
set tmp=%line%
:loop
:: get first two characters from input
SET sub=%tmp:~0,2%
:: remove first character from input
SET tmp=%tmp:~2%
REM add to newline
set newline=!newline!%sub%%space%
:: repeat until only the string terminator is left
set /A count=count+1
IF NOT %count% EQU 16 GOTO loop 
set line=%newline:~0,-1%